/**
 * NEURON IIoT System for Industry 4.0
 * Copyright (C) 2020-2021 EMQ Technologies Co., Ltd All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 **/

/*
 * DO NOT EDIT THIS FILE MANUALLY!
 * It was automatically generated by `json-autotype`.
 */

#ifndef _NEU_JSON_API_NEU_JSON_GROUP_CONFIG_H_
#define _NEU_JSON_API_NEU_JSON_GROUP_CONFIG_H_

#include "json/json.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
    char *  name;
    int64_t node_id;
    int64_t interval;
} neu_json_add_group_config_req_t;

int neu_json_decode_add_group_config_req(
    char *buf, neu_json_add_group_config_req_t **result);
void neu_json_decode_add_group_config_req_free(
    neu_json_add_group_config_req_t *req);

typedef struct {
    char *  name;
    int64_t node_id;
} neu_json_del_group_config_req_t;

int neu_json_decode_del_group_config_req(
    char *buf, neu_json_del_group_config_req_t **result);
void neu_json_decode_del_group_config_req_free(
    neu_json_del_group_config_req_t *req);

typedef struct {
    int64_t node_id;
} neu_json_get_group_config_req_t;

int neu_json_decode_get_group_config_req(
    char *buf, neu_json_get_group_config_req_t **result);
void neu_json_decode_get_group_config_req_free(
    neu_json_get_group_config_req_t *req);

typedef struct {
    char *  name;
    int64_t pipe_count;
    int64_t interval;
    int64_t tag_count;
} neu_json_get_group_config_resp_group_config_t;

typedef struct {
    int                                            n_group_config;
    neu_json_get_group_config_resp_group_config_t *group_configs;
} neu_json_get_group_config_resp_t;

int neu_json_encode_get_group_config_resp(void *json_object, void *param);

typedef struct {
    char *  group_config_name;
    int64_t node_id;
} neu_json_get_subscribe_resp_group_t;

typedef struct {
    int                                  n_group;
    neu_json_get_subscribe_resp_group_t *groups;
} neu_json_get_subscribe_resp_t;

int neu_json_encode_get_subscribe_resp(void *json_object, void *param);

typedef struct {
    char *  name;
    int64_t src_node_id;
    int64_t dst_node_id;
} neu_json_subscribe_req_t;

int neu_json_decode_subscribe_req(char *buf, neu_json_subscribe_req_t **result);
void neu_json_decode_subscribe_req_free(neu_json_subscribe_req_t *req);

typedef struct {
    char *  name;
    int64_t src_node_id;
    int64_t dst_node_id;
} neu_json_unsubscribe_req_t;

int  neu_json_decode_unsubscribe_req(char *                       buf,
                                     neu_json_unsubscribe_req_t **result);
void neu_json_decode_unsubscribe_req_free(neu_json_unsubscribe_req_t *req);

typedef struct {
    char *  name;
    int64_t node_id;
    int64_t interval;
} neu_json_update_group_config_req_t;

int neu_json_decode_update_group_config_req(
    char *buf, neu_json_update_group_config_req_t **result);
void neu_json_decode_update_group_config_req_free(
    neu_json_update_group_config_req_t *req);

#ifdef __cplusplus
}
#endif

#endif
