/**
 * NEURON IIoT System for Industry 4.0
 * Copyright (C) 2020-2021 EMQ Technologies Co., Ltd All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 **/

/*
 * DO NOT EDIT THIS FILE MANUALLY!
 * It was automatically generated by `json-autotype`.
 */

#include <stdlib.h>
#include <string.h>

#include "json/json.h"

#include "json/neu_json_group_config.h"

int neu_json_decode_add_group_config_req(
    char *buf, neu_json_add_group_config_req_t **result)
{
    int                              ret      = 0;
    void *                           json_obj = NULL;
    neu_json_add_group_config_req_t *req =
        calloc(1, sizeof(neu_json_add_group_config_req_t));
    if (req == NULL) {
        return -1;
    }

    json_obj = neu_json_decode_new(buf);

    neu_json_elem_t req_elems[] = { {
                                        .name = "node_id",
                                        .t    = NEU_JSON_INT,
                                    },
                                    {
                                        .name = "name",
                                        .t    = NEU_JSON_STR,
                                    },
                                    {
                                        .name = "interval",
                                        .t    = NEU_JSON_INT,
                                    } };
    ret = neu_json_decode_by_json(json_obj, NEU_JSON_ELEM_SIZE(req_elems),
                                  req_elems);
    if (ret != 0) {
        goto decode_fail;
    }

    req->node_id  = req_elems[0].v.val_int;
    req->name     = req_elems[1].v.val_str;
    req->interval = req_elems[2].v.val_int;

    *result = req;
    goto decode_exit;

decode_fail:
    if (req != NULL) {
        free(req);
    }
    ret = -1;

decode_exit:
    if (json_obj != NULL) {
        neu_json_decode_free(json_obj);
    }
    return ret;
}

void neu_json_decode_add_group_config_req_free(
    neu_json_add_group_config_req_t *req)
{

    free(req->name);

    free(req);
}

int neu_json_decode_del_group_config_req(
    char *buf, neu_json_del_group_config_req_t **result)
{
    int                              ret      = 0;
    void *                           json_obj = NULL;
    neu_json_del_group_config_req_t *req =
        calloc(1, sizeof(neu_json_del_group_config_req_t));
    if (req == NULL) {
        return -1;
    }

    json_obj = neu_json_decode_new(buf);

    neu_json_elem_t req_elems[] = { {
                                        .name = "node_id",
                                        .t    = NEU_JSON_INT,
                                    },
                                    {
                                        .name = "name",
                                        .t    = NEU_JSON_STR,
                                    } };
    ret = neu_json_decode_by_json(json_obj, NEU_JSON_ELEM_SIZE(req_elems),
                                  req_elems);
    if (ret != 0) {
        goto decode_fail;
    }

    req->node_id = req_elems[0].v.val_int;
    req->name    = req_elems[1].v.val_str;

    *result = req;
    goto decode_exit;

decode_fail:
    if (req != NULL) {
        free(req);
    }
    ret = -1;

decode_exit:
    if (json_obj != NULL) {
        neu_json_decode_free(json_obj);
    }
    return ret;
}

void neu_json_decode_del_group_config_req_free(
    neu_json_del_group_config_req_t *req)
{

    free(req->name);

    free(req);
}

int neu_json_decode_get_group_config_req(
    char *buf, neu_json_get_group_config_req_t **result)
{
    int                              ret      = 0;
    void *                           json_obj = NULL;
    neu_json_get_group_config_req_t *req =
        calloc(1, sizeof(neu_json_get_group_config_req_t));
    if (req == NULL) {
        return -1;
    }

    json_obj = neu_json_decode_new(buf);

    neu_json_elem_t req_elems[] = { {
        .name = "node_id",
        .t    = NEU_JSON_INT,
    } };
    ret = neu_json_decode_by_json(json_obj, NEU_JSON_ELEM_SIZE(req_elems),
                                  req_elems);
    if (ret != 0) {
        goto decode_fail;
    }

    req->node_id = req_elems[0].v.val_int;

    *result = req;
    goto decode_exit;

decode_fail:
    if (req != NULL) {
        free(req);
    }
    ret = -1;

decode_exit:
    if (json_obj != NULL) {
        neu_json_decode_free(json_obj);
    }
    return ret;
}

void neu_json_decode_get_group_config_req_free(
    neu_json_get_group_config_req_t *req)
{

    free(req);
}

int neu_json_encode_get_group_config_resp(void *json_object, void *param)
{
    int                               ret = 0;
    neu_json_get_group_config_resp_t *resp =
        (neu_json_get_group_config_resp_t *) param;

    void *group_config_array = neu_json_array();
    neu_json_get_group_config_resp_group_config_t *p_group_config =
        resp->group_configs;
    for (int i = 0; i < resp->n_group_config; i++) {
        neu_json_elem_t group_config_elems[] = {
            {
                .name      = "tag_count",
                .t         = NEU_JSON_INT,
                .v.val_int = p_group_config->tag_count,
            },
            {
                .name      = "pipe_count",
                .t         = NEU_JSON_INT,
                .v.val_int = p_group_config->pipe_count,
            },
            {
                .name      = "name",
                .t         = NEU_JSON_STR,
                .v.val_str = p_group_config->name,
            },
            {
                .name      = "interval",
                .t         = NEU_JSON_INT,
                .v.val_int = p_group_config->interval,
            }
        };
        group_config_array =
            neu_json_encode_array(group_config_array, group_config_elems,
                                  NEU_JSON_ELEM_SIZE(group_config_elems));
        p_group_config++;
    }

    neu_json_elem_t resp_elems[] = { {
        .name         = "group_configs",
        .t            = NEU_JSON_OBJECT,
        .v.val_object = group_config_array,
    } };
    ret = neu_json_encode_field(json_object, resp_elems,
                                NEU_JSON_ELEM_SIZE(resp_elems));

    return ret;
}

int neu_json_encode_get_subscribe_resp(void *json_object, void *param)
{
    int                            ret = 0;
    neu_json_get_subscribe_resp_t *resp =
        (neu_json_get_subscribe_resp_t *) param;

    void *                               group_array = neu_json_array();
    neu_json_get_subscribe_resp_group_t *p_group     = resp->groups;
    for (int i = 0; i < resp->n_group; i++) {
        neu_json_elem_t group_elems[] = { {
                                              .name      = "node_id",
                                              .t         = NEU_JSON_INT,
                                              .v.val_int = p_group->node_id,
                                          },
                                          {
                                              .name = "group_config_name",
                                              .t    = NEU_JSON_STR,
                                              .v.val_str =
                                                  p_group->group_config_name,
                                          } };
        group_array = neu_json_encode_array(group_array, group_elems,
                                            NEU_JSON_ELEM_SIZE(group_elems));
        p_group++;
    }

    neu_json_elem_t resp_elems[] = { {
        .name         = "groups",
        .t            = NEU_JSON_OBJECT,
        .v.val_object = group_array,
    } };
    ret = neu_json_encode_field(json_object, resp_elems,
                                NEU_JSON_ELEM_SIZE(resp_elems));

    return ret;
}

int neu_json_decode_subscribe_req(char *buf, neu_json_subscribe_req_t **result)
{
    int                       ret      = 0;
    void *                    json_obj = NULL;
    neu_json_subscribe_req_t *req = calloc(1, sizeof(neu_json_subscribe_req_t));
    if (req == NULL) {
        return -1;
    }

    json_obj = neu_json_decode_new(buf);

    neu_json_elem_t req_elems[] = { {
                                        .name = "src_node_id",
                                        .t    = NEU_JSON_INT,
                                    },
                                    {
                                        .name = "name",
                                        .t    = NEU_JSON_STR,
                                    },
                                    {
                                        .name = "dst_node_id",
                                        .t    = NEU_JSON_INT,
                                    } };
    ret = neu_json_decode_by_json(json_obj, NEU_JSON_ELEM_SIZE(req_elems),
                                  req_elems);
    if (ret != 0) {
        goto decode_fail;
    }

    req->src_node_id = req_elems[0].v.val_int;
    req->name        = req_elems[1].v.val_str;
    req->dst_node_id = req_elems[2].v.val_int;

    *result = req;
    goto decode_exit;

decode_fail:
    if (req != NULL) {
        free(req);
    }
    ret = -1;

decode_exit:
    if (json_obj != NULL) {
        neu_json_decode_free(json_obj);
    }
    return ret;
}

void neu_json_decode_subscribe_req_free(neu_json_subscribe_req_t *req)
{

    free(req->name);

    free(req);
}

int neu_json_decode_unsubscribe_req(char *                       buf,
                                    neu_json_unsubscribe_req_t **result)
{
    int                         ret      = 0;
    void *                      json_obj = NULL;
    neu_json_unsubscribe_req_t *req =
        calloc(1, sizeof(neu_json_unsubscribe_req_t));
    if (req == NULL) {
        return -1;
    }

    json_obj = neu_json_decode_new(buf);

    neu_json_elem_t req_elems[] = { {
                                        .name = "src_node_id",
                                        .t    = NEU_JSON_INT,
                                    },
                                    {
                                        .name = "name",
                                        .t    = NEU_JSON_STR,
                                    },
                                    {
                                        .name = "dst_node_id",
                                        .t    = NEU_JSON_INT,
                                    } };
    ret = neu_json_decode_by_json(json_obj, NEU_JSON_ELEM_SIZE(req_elems),
                                  req_elems);
    if (ret != 0) {
        goto decode_fail;
    }

    req->src_node_id = req_elems[0].v.val_int;
    req->name        = req_elems[1].v.val_str;
    req->dst_node_id = req_elems[2].v.val_int;

    *result = req;
    goto decode_exit;

decode_fail:
    if (req != NULL) {
        free(req);
    }
    ret = -1;

decode_exit:
    if (json_obj != NULL) {
        neu_json_decode_free(json_obj);
    }
    return ret;
}

void neu_json_decode_unsubscribe_req_free(neu_json_unsubscribe_req_t *req)
{

    free(req->name);

    free(req);
}

int neu_json_decode_update_group_config_req(
    char *buf, neu_json_update_group_config_req_t **result)
{
    int                                 ret      = 0;
    void *                              json_obj = NULL;
    neu_json_update_group_config_req_t *req =
        calloc(1, sizeof(neu_json_update_group_config_req_t));
    if (req == NULL) {
        return -1;
    }

    json_obj = neu_json_decode_new(buf);

    neu_json_elem_t req_elems[] = { {
                                        .name = "node_id",
                                        .t    = NEU_JSON_INT,
                                    },
                                    {
                                        .name = "name",
                                        .t    = NEU_JSON_STR,
                                    },
                                    {
                                        .name = "interval",
                                        .t    = NEU_JSON_INT,
                                    } };
    ret = neu_json_decode_by_json(json_obj, NEU_JSON_ELEM_SIZE(req_elems),
                                  req_elems);
    if (ret != 0) {
        goto decode_fail;
    }

    req->node_id  = req_elems[0].v.val_int;
    req->name     = req_elems[1].v.val_str;
    req->interval = req_elems[2].v.val_int;

    *result = req;
    goto decode_exit;

decode_fail:
    if (req != NULL) {
        free(req);
    }
    ret = -1;

decode_exit:
    if (json_obj != NULL) {
        neu_json_decode_free(json_obj);
    }
    return ret;
}

void neu_json_decode_update_group_config_req_free(
    neu_json_update_group_config_req_t *req)
{

    free(req->name);

    free(req);
}
