/**
 * NEURON IIoT System for Industry 4.0
 * Copyright (C) 2020-2022 EMQ Technologies Co., Ltd All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 **/

/*
 * DO NOT EDIT THIS FILE MANUALLY!
 * It was automatically generated by `json-autotype`.
 */

#include <stdlib.h>
#include <string.h>

#include "json/json.h"

#include "persist_json_adapter.h"

int neu_json_encode_node_resp(void *json_object, void *param)
{
    int                   ret  = 0;
    neu_json_node_resp_t *resp = (neu_json_node_resp_t *) param;

    void *                     node_array = neu_json_array();
    neu_json_node_resp_node_t *p_node     = resp->nodes;
    for (int i = 0; i < resp->n_node; i++) {
        neu_json_elem_t node_elems[] = { {
                                             .name      = "type",
                                             .t         = NEU_JSON_INT,
                                             .v.val_int = p_node->type,
                                         },
                                         {
                                             .name      = "state",
                                             .t         = NEU_JSON_INT,
                                             .v.val_int = p_node->state,
                                         },
                                         {
                                             .name      = "plugin_name",
                                             .t         = NEU_JSON_STR,
                                             .v.val_str = p_node->plugin_name,
                                         },
                                         {
                                             .name      = "name",
                                             .t         = NEU_JSON_STR,
                                             .v.val_str = p_node->name,
                                         },
                                         {
                                             .name      = "id",
                                             .t         = NEU_JSON_INT,
                                             .v.val_int = p_node->id,
                                         } };
        node_array = neu_json_encode_array(node_array, node_elems,
                                           NEU_JSON_ELEM_SIZE(node_elems));
        p_node++;
    }

    neu_json_elem_t resp_elems[] = { {
        .name         = "nodes",
        .t            = NEU_JSON_OBJECT,
        .v.val_object = node_array,
    } };
    ret = neu_json_encode_field(json_object, resp_elems,
                                NEU_JSON_ELEM_SIZE(resp_elems));

    return ret;
}

int neu_json_decode_node_req(char *buf, neu_json_node_req_t **result)
{
    int                  ret = 0;
    neu_json_node_req_t *req = calloc(1, sizeof(neu_json_node_req_t));

    req->n_node = neu_json_decode_array_size(buf, "nodes");
    req->nodes  = calloc(req->n_node, sizeof(neu_json_node_req_node_t));
    neu_json_node_req_node_t *p_node = req->nodes;
    for (int i = 0; i < req->n_node; i++) {
        neu_json_elem_t node_elems[] = { {
                                             .name = "type",
                                             .t    = NEU_JSON_INT,
                                         },
                                         {
                                             .name = "state",
                                             .t    = NEU_JSON_INT,
                                         },
                                         {
                                             .name = "plugin_name",
                                             .t    = NEU_JSON_STR,
                                         },
                                         {
                                             .name = "name",
                                             .t    = NEU_JSON_STR,
                                         },
                                         {
                                             .name = "id",
                                             .t    = NEU_JSON_INT,
                                         } };
        ret                          = neu_json_decode_array(buf, "nodes", i,
                                    NEU_JSON_ELEM_SIZE(node_elems), node_elems);
        if (ret != 0) {
            goto decode_fail;
        }

        p_node->type        = node_elems[0].v.val_int;
        p_node->state       = node_elems[1].v.val_int;
        p_node->plugin_name = node_elems[2].v.val_str;
        p_node->name        = node_elems[3].v.val_str;
        p_node->id          = node_elems[4].v.val_int;
        p_node++;
    }

    *result = req;
    return ret;

decode_fail:
    if (req->nodes != NULL) {
        free(req->nodes);
    }
    if (req != NULL) {
        free(req);
    }
    return -1;
}

void neu_json_decode_node_req_free(neu_json_node_req_t *req)
{

    neu_json_node_req_node_t *p_node = req->nodes;
    for (int i = 0; i < req->n_node; i++) {
        free(p_node->plugin_name);
        free(p_node->name);
        p_node++;
    }

    free(req->nodes);

    free(req);
}
